// Created by Patrick McCabe

PImage img;
float scaleFactor = 1;
int scaleNumerator=1;
int scaleDenominator=1;
float imageWidth;
float imageHeight;
int pixelSize = 2;
int readingX;
int readingY;
int averageColor;
int etchWidth;

int columns;
int rows;
int pixelArray[];

boolean averagingPixels = false;
boolean loadedImage = false;
boolean etch = false;

String photoName = "";
boolean enteringName = false;

PrintWriter outputFile;

void setup(){
  size(1663,800);
  background(100);

  
  fill(255,0,0);
  rect(800,0,863,750); // etch a sketch outside red
  fill(200);
  rect(850,50,763,545); // etch a sketch screen
  fill(255);
  text("Etch-A-Sketch", 1200,25);
  
  fill(80,0,0);
  rect(0,650,1663,150);
  fill(255);
  text("File Name:",10,680);
  rect(10,690,180,30);  // file name box
  
  text("Pixel Size:",10,750);
  rect(10,760,180,30); // pixel size slider box
  rect(80,735,30,20);  // display boxfor pixel size
  fill(0);
  text(pixelSize,90,750);
  
  fill(255);
  text("Average Pixels:",230,680);
  rect(330,665,20,20);
  
  fill(255);
  text("Scale Factor:",230,720);
  rect(320,705,50,20);  // scale factor display box
  rect(230,735,180,20); // scale factor numerator slider
  rect(230,765,180,20); // scale factor denominator slider
  fill(0);
  text(scaleNumerator,325,720);
  text("/",340,720);
  text(scaleDenominator,350,720);
  
  fill(255,0,0);
  rect(450,700,100,40);
  fill(0);
  text("Etch",485,725);
}

void draw(){
  
}



void mousePressed(){
  if(mouseX>=10 && mouseX<=190 && mouseY>=690 && mouseY<=720){ // clicked in photo name box
    enteringName = true;
  }
  if(mouseX>=10 && mouseX<=190 && mouseY>=760 && mouseY<=790){ // clicked in pixel size slider
    fill(255);
    rect(10,760,180,30); 
    fill(0,0,255);
    rect(10,760,mouseX-10,30);
    pixelSize = int(map(mouseX-10,0,180,2,25));
    fill(255);
    rect(80,735,30,20);  // display boxfor pixel size
    fill(0);
    text(pixelSize,90,750);
    adjustPixelSize();
  }
  if(mouseX>=330 && mouseX<=350 && mouseY>=665 && mouseY<=685){ // clicked on average pixel box
    if(averagingPixels == false){
      averagingPixels = true;
      fill(0,255,0);
      rect(330,665,20,20);
      adjustPixelSize();
    }
    else{
      averagingPixels = false;
      fill(255);
      rect(330,665,20,20);
      adjustPixelSize();
    }
  }
  
  if(mouseX>=230 && mouseX<=410 && mouseY>=735 && mouseY<=755){ // numerator scale factor slider
    fill(255);
    rect(320,705,50,20);  // scale factor display box
    rect(230,735,180,20); // scale factor numerator slider
    fill(0,0,255);
    rect(230,735,mouseX-230,20);
    scaleNumerator = int(map(mouseX-230,0,180,1,10));
    fill(0);
    text(scaleNumerator,325,720);
    text("/",340,720);
    text(scaleDenominator,350,720);
    adjustPixelSize();
  }
  
  if(mouseX>=230 && mouseX<=410 && mouseY>=765 && mouseY<=785){ // denominator scale factor slider
    fill(255);
    rect(320,705,50,20);  // scale factor display box
    rect(230,765,180,20); // scale factor denominator slider
    fill(0,0,255);
    rect(230,765,mouseX-230,20);
    scaleDenominator = int(map(mouseX-230,0,180,1,10));
    fill(0);
    text(scaleNumerator,325,720);
    text("/",340,720);
    text(scaleDenominator,350,720);
    adjustPixelSize();
  }
  if(mouseX>=450 && mouseX<=550 && mouseY>=700 && mouseY<=740){ // clicked in photo name box
    if(etch == false){
      fill(0,255,0);
      rect(450,700,100,40);
      fill(0);
      text("Etch",485,725);
      etch = true;
      averageImage();
    }
    else{
      fill(255,0,0);
      rect(450,700,100,40);
      fill(0);
      text("Etch",485,725);
      etch = false;
    }
  }
  
  
}

void mouseDragged(){
  if(mouseX>=10 && mouseX<=190 && mouseY>=760 && mouseY<=790){ // clicked in pixel size slider
    fill(255);
    rect(10,760,180,30); 
    fill(0,0,255);
    rect(10,760,mouseX-10,30);
    pixelSize = int(map(mouseX-10,0,180,2,25));
    fill(255);
    rect(80,735,30,20);  // display box for pixel size
    fill(0);
    text(pixelSize,90,750);
    adjustPixelSize();
  }
  if(mouseX>=230 && mouseX<=410 && mouseY>=735 && mouseY<=755){ // numerator scale factor slider
    fill(255);
    rect(320,705,50,20);  // scale factor display box
    rect(230,735,180,20); // scale factor numerator slider
    fill(0,0,255);
    rect(230,735,mouseX-230,20);
    scaleNumerator = int(map(mouseX-230,0,180,1,10));
    fill(0);
    text(scaleNumerator,325,720);
    text("/",340,720);
    text(scaleDenominator,350,720);
    adjustPixelSize();
  }
  
  if(mouseX>=230 && mouseX<=410 && mouseY>=765 && mouseY<=785){ // denominator scale factor slider
    fill(255);
    rect(320,705,50,20);  // scale factor display box
    rect(230,765,180,20); // scale factor denominator slider
    fill(0,0,255);
    rect(230,765,mouseX-230,20);
    scaleDenominator = int(map(mouseX-230,0,180,1,10));
    fill(0);
    text(scaleNumerator,325,720);
    text("/",340,720);
    text(scaleDenominator,350,720);
    adjustPixelSize();
  }
  
}

void keyPressed(){
  if(enteringName == true && key>='!' && key<='z'){
    photoName += char(key);
    fill(255);
    rect(10,690,180,30);
    fill(0);
    text(photoName,20,710);
  }
  else if(enteringName == true && key == ENTER){
    enteringName = false;
    loadedImage = true;
    adjustPixelSize();
  }
  else if(enteringName == true && key == BACKSPACE && photoName.length()>0){
    photoName = photoName.substring(0,photoName.length()-1 );
    fill(255);
    rect(10,690,180,30);
    fill(0);
    text(photoName,20,710);
  }
}

void loadPhoto(){
  fill(100);
  rect(0,0,800,650);
  img = loadImage(photoName);

  if(img.width > 800 || img.height > 650 && loadedImage == true){
    int scaleWidth = img.width / width;
    int scaleHeight = img.height / 650;
    if(scaleWidth > scaleHeight){
      scaleDenominator = scaleWidth;
    }
    else{
      scaleDenominator = scaleHeight;
    }
    scaleDenominator+=1;
    //println(scaleDenominator);
  }
  loadedImage = false;
  
  scaleFactor = float(scaleNumerator) / scaleDenominator;
  
  if(img.width*scaleFactor < 800 && img.height*scaleFactor < 650){
    imageWidth = (img.width)*scaleFactor;
    imageHeight = (img.height)*scaleFactor;
  }
  
  imageWidth = int(imageWidth)/pixelSize;
  imageHeight = int(imageHeight)/pixelSize;
  columns = int(imageWidth);
  rows = int(imageHeight);
  imageWidth*= pixelSize;
  imageHeight*=pixelSize;
  //println(imageWidth);
  //println(imageHeight);
  image(img,0,0,imageWidth,imageHeight);
  img.resize(int(imageWidth),int(imageHeight));
  
  if(averagingPixels == true){
    averageImage();
  }
}

void adjustPixelSize(){
  if(photoName.equals("") == false){
    loadPhoto();
    stroke(100,0,0);
    for(int x=pixelSize; x<imageWidth; x+=pixelSize){
      line(x,0,x,imageHeight);
    }
    for(int y=pixelSize; y<imageHeight; y+=pixelSize){
      line(0,y,imageWidth,y);
    }
  }
}

void averageImage(){
  loadPixels();
  pixelArray = new int [rows*columns];
  for(int mainY=0; mainY<imageHeight; mainY+=pixelSize){
    for(int mainX=0; mainX<imageWidth; mainX+=pixelSize){
      for(int dy=0; dy<pixelSize; dy++){
        for(int dx=0; dx<pixelSize; dx++){
          readingX = mainX+dx;
          readingY = mainY+dy;
          color currColor = img.pixels[int(readingY*imageWidth)+readingX];
          int currR = (currColor >> 16) & 0xFF;
          int currG = (currColor >> 8) & 0xFF;
          int currB = currColor & 0xFF;
          averageColor+=int((currR+currG+currB)/3.0);
        }
      }
      averageColor/=(pixelSize*pixelSize);
      //println(averageColor);
      pixelArray[((mainY/pixelSize)*columns) + (mainX/pixelSize)] = averageColor;
      fill(averageColor);
      rect(mainX,mainY,pixelSize,pixelSize);
      averageColor=0;
    }
  }
  if(etch == true){
    etchImage();
  }
}

void etchImage(){
  
    outputFile = createWriter(photoName.substring(0,photoName.indexOf(".")) + ".txt");
    fill(200);
    rect(850,50,763,545);
    int boxWidth = 763/columns;
    println("boxWidth: " + boxWidth);
    int boxHeight = 545/rows;
    println("boxHeight: " + boxHeight);
    println("rows: " + rows);
    println("columns: " + columns);
    outputFile.print(boxWidth + " ");
    outputFile.print(rows + " ");
    outputFile.print(columns + " ");
    int yValue = 50;
    int xValue = 850;
    
    for(int yi=0; yi<rows; yi++){
      xValue = 850;
      yValue = 50+(yi*boxHeight);
      for(int xi=0; xi<columns; xi++){
        int colorToSketch = pixelArray[(yi*columns)+xi];
        colorToSketch = int(map(colorToSketch,0,255,boxWidth,1));
        
        etchWidth = boxWidth / colorToSketch;
        if(etchWidth == 0){
          etchWidth+=1;
        }
        etchWidth = int(map(etchWidth,1,boxWidth,2,boxWidth));
        outputFile.print(etchWidth);
        outputFile.print(" ");
       
        
        for(int i=0; i+etchWidth<=boxWidth; i+=etchWidth){
          if(etchWidth != boxWidth){
            stroke(0);
            line(xValue,yValue,xValue,yValue+boxHeight);
          }
          xValue += etchWidth;
        }
      }
      
      xValue = 850;
      yValue = 50+(yi*boxHeight);
      int altValue = 0;
      for(int i=0; i+etchWidth<=boxWidth*columns; i+=etchWidth){
        if(altValue == 0){
          line(xValue,yValue,xValue+etchWidth,yValue);
          xValue += etchWidth;
          altValue=1;
        }
        else{
          line(xValue,yValue+boxHeight,xValue+etchWidth,yValue+boxHeight);
          xValue += etchWidth;
          altValue=0;
        }
      }    
    }
    
    outputFile.flush(); // Writes the remaining data to the file
    outputFile.close(); // Finishes the file
    
}
